﻿package pacotes {

public class Matrizes {


	
	public static function MatrizPorVetor(A:Array, B:Array):Array {
	  
		var C:Array = [];
	
		C[0] = A[0][0]*B[0] + A[0][1]*B[1] + A[0][2]*B[2];
		C[1] = A[1][0]*B[0] + A[1][1]*B[1] + A[1][2]*B[2];
		C[2] = A[2][0]*B[0] + A[2][1]*B[1] + A[2][2]*B[2]; 

		return C;
	}


	
	public static function MatrizPorMatriz(A:Array, B:Array):Array {
	
		var C:Array=[];
	
		var i:Number;
	
		for(i=0;i<3;i++){
		
			C[i]=[];
		
		}
	
		C[0][0] = A[0][0]*B[0][0] + A[0][1]*B[1][0] + A[0][2]*B[2][0];
		C[0][1] = A[0][0]*B[0][1] + A[0][1]*B[1][1] + A[0][2]*B[2][1];
		C[0][2] = A[0][0]*B[0][2] + A[0][1]*B[1][2] + A[0][2]*B[2][2];
		C[1][0] = A[1][0]*B[0][0] + A[1][1]*B[1][0] + A[1][2]*B[2][0];
		C[1][1] = A[1][0]*B[0][1] + A[1][1]*B[1][1] + A[1][2]*B[2][1];
		C[1][2] = A[1][0]*B[0][2] + A[1][1]*B[1][2] + A[1][2]*B[2][2];
		C[2][0] = A[2][0]*B[0][0] + A[2][1]*B[1][0] + A[2][2]*B[2][0];
		C[2][1] = A[2][0]*B[0][1] + A[2][1]*B[1][1] + A[2][2]*B[2][1];
		C[2][2] = A[2][0]*B[0][2] + A[2][1]*B[1][2] + A[2][2]*B[2][2];

		return C;
	
	}



	public static function projetaPonto(ponto:Array,distObsOrig:Number):Array {
	
		var projecao:Array=[];
	
		projecao[0] = distObsOrig/(distObsOrig - ponto[2])*ponto[0];
	
		projecao[1] = distObsOrig/(distObsOrig - ponto[2])*ponto[1];

		return projecao;
	
	}



	public static function matrizRotacao(x:Number, y:Number, z:Number, theta:Number):Array {
	
		var distEixoXOrig:Number;
	
		var T:Array=[];
	
		var radtheta:Number;
		
		var i:Number;
	
		var cosT:Number;
	
		var sinT:Number;
	
		var difT:Number;
	
		radtheta=Math.PI*theta/180;

		distEixoXOrig = Math.sqrt(x*x + y*y + z*z);
	
		for(i=0;i<3;i++){
		
			T[i]=[];
		
		}
	
		T =[[1,0,0], [0,1,0], [0,0,1]];
	
		if (distEixoXOrig>.0001) {
		
			x /= distEixoXOrig;
			y /= distEixoXOrig;
			z /= distEixoXOrig;
			
			cosT = Math.cos(radtheta);
			sinT = Math.sin(radtheta);
			difT = 1-cosT;

			T[0][0] = difT*x*x + cosT;    T[0][1] = difT*x*y - sinT*z;  T[0][2] = difT*x*z + sinT*y;
			T[1][0] = difT*x*y + sinT*z;  T[1][1] = difT*y*y + cosT;    T[1][2] = difT*y*z - sinT*x;
			T[2][0] = difT*x*z - sinT*y;  T[2][1] = difT*y*z + sinT*x;  T[2][2] = difT*z*z + cosT;
		}
	
		return T;
	}

		
}

}